/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.system.action;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.kintai.common.action.KintaiCommonAction;
import jp.mosp.kintai.common.dao.MSyozokuDao;
import jp.mosp.kintai.common.dto.MSyozokuDto;
import jp.mosp.kintai.system.vo.SyozokuMasterCardVo;

/**
 * @author yoshida
 *
 */
public class SyozokuMasterCardAction extends KintaiCommonAction {
	
	// コマンド
	private static final String	CMD_SYOZOKU_CARD_SHOW	= "S2105";	// 表示(追加)
	private static final String	CMD_SYOZOKU_CARD_SELECT	= "S2106";	// 表示(選択)
	private static final String	CMD_SYOZOKU_CARD_INSERT	= "S2107";	// 登録
	private static final String	CMD_SYOZOKU_CARD_UPDATE	= "S2108";	// 更新
	private static final String	CMD_SYOZOKU_CARD_DELETE	= "S2109";	// 削除
																	
	
	/**
	 * コンストラクタ
	 */
	public SyozokuMasterCardAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得及び設定		
		prepareVo(false);
		// 初期処理 
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_SYOZOKU_CARD_SHOW)) {
			// 表示(新規)
			show();
		} else if (cmd.equals(CMD_SYOZOKU_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select();
		} else if (cmd.equals(CMD_SYOZOKU_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_SYOZOKU_CARD_UPDATE)) {
			// 更新
			update();
		} else if (cmd.equals(CMD_SYOZOKU_CARD_DELETE)) {
			// 削除
			delete();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new SyozokuMasterCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
	}
	
	@Override
	protected void show() {
		SyozokuMasterCardVo vo = (SyozokuMasterCardVo)getVo();
		vo.setTxtSCode1("");
		vo.setTxtSCode2("");
		vo.setTxtSCode3("");
		vo.setTxtSName("");
		vo.setMode(SyozokuMasterCardVo.MODE_INSERT);
	}
	
	@Override
	protected void select() throws Exception {
		SyozokuMasterCardVo vo = (SyozokuMasterCardVo)getVo();
		// データの取得
		MSyozokuDto dto = part().section().getSectionInfo(key1);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		setMode();
		//セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		SyozokuMasterCardVo vo = (SyozokuMasterCardVo)getVo();
		vo.setParams(request);
		// パラメーターの妥当性確認
		vo.validate();
		// DTOの準備
		MSyozokuDto dto = new MSyozokuDto();
		vo.setDtoFields(dto);
		// DAOの準備
		MSyozokuDao dao = part().section().getMSyozokuDao();
		// 存在チェック
		chkDuplicate(dao.findForKey(dto.getSCode()));
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		MSyozokuDto retDto = dao.findForKey(dto.getSCode());
		chkInsert(retDto);
		// コミット
		commit();
		// モード設定
		setMode();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得
		MSyozokuDto dto = (MSyozokuDto)getSessionDto();
		SyozokuMasterCardVo vo = (SyozokuMasterCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// DAOの準備
		MSyozokuDao dao = part().section().getMSyozokuDao();
		// DTOの準備
		vo.setDtoFields(dto);
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(dto.getSCode()));
		// データの更新
		dao.update(dto);
		// DTOの再取得
		MSyozokuDto retDto = dao.findForKey(dto.getSCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		setMode();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	/**
	 * データ削除
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void delete() throws Exception {
		// DTOの取得
		MSyozokuDto dto = (MSyozokuDto)getSessionDto();
		SyozokuMasterCardVo vo = (SyozokuMasterCardVo)getVo();
		// データの更新
		part().section().getMSyozokuDao().delete(dto);
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_DELETE, ""));
	}
	
	/**
	 * モード設定
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void setMode() throws Exception {
		SyozokuMasterCardVo vo = (SyozokuMasterCardVo)getVo();
		// モード設定
		if (hasSystemAuth()) {
			vo.setMode(SyozokuMasterCardVo.MODE_SYSTEM);
		} else {
			vo.setMode(SyozokuMasterCardVo.MODE_UPDATE);
		}
	}
	
}
